;; NOTE: Assertions have been generated by update_lit_checks.py --all-items and should not be edited.

;; Test in both "always" mode, which always monomorphizes, and in "careful"
;; mode which does it only when it appears to actually help. Also use a minimum
;; benefit of 0 to make it easy to write small testcases in careful mode.

;; RUN: foreach %s %t wasm-opt --monomorphize-always                                -all -S -o - | filecheck %s --check-prefix ALWAYS
;; RUN: foreach %s %t wasm-opt --monomorphize --pass-arg=monomorphize-min-benefit@0 -all -S -o - | filecheck %s --check-prefix CAREFUL

(module
  ;; ALWAYS:      (type $A (sub (struct)))
  ;; CAREFUL:      (type $A (sub (struct)))
  (type $A (sub (struct)))
  ;; ALWAYS:      (type $B (sub $A (struct)))
  ;; CAREFUL:      (type $B (sub $A (struct)))
  (type $B (sub $A (struct)))

  ;; ALWAYS:      (type $2 (func (param (ref $A))))

  ;; ALWAYS:      (type $3 (func (param (ref $B))))

  ;; ALWAYS:      (type $4 (func (param (ref $A) (ref $B))))

  ;; ALWAYS:      (import "a" "b" (func $import (type $2) (param (ref $A))))
  ;; CAREFUL:      (type $2 (func (param (ref $A))))

  ;; CAREFUL:      (type $3 (func (param (ref $A) (ref $B))))

  ;; CAREFUL:      (type $4 (func (param (ref $B))))

  ;; CAREFUL:      (import "a" "b" (func $import (type $2) (param (ref $A))))
  (import "a" "b" (func $import (param (ref $A))))

  ;; ALWAYS:      (func $calls (type $4) (param $A (ref $A)) (param $B (ref $B))
  ;; ALWAYS-NEXT:  (call $refinable
  ;; ALWAYS-NEXT:   (local.get $A)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (call $refinable
  ;; ALWAYS-NEXT:   (local.get $A)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (call $refinable_4
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (call $refinable_4
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT: )
  ;; CAREFUL:      (func $calls (type $3) (param $A (ref $A)) (param $B (ref $B))
  ;; CAREFUL-NEXT:  (call $refinable
  ;; CAREFUL-NEXT:   (local.get $A)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT:  (call $refinable
  ;; CAREFUL-NEXT:   (local.get $A)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT:  (call $refinable
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT:  (call $refinable
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT: )
  (func $calls (param $A (ref $A)) (param $B (ref $B))
    ;; Two calls with $A, two with $B. The calls to $B should both go to the
    ;; same new function which has a refined parameter of $B.
    ;;
    ;; However, in CAREFUL mode we won't do that, as there is no helpful
    ;; improvement in the target functions even with the refined types.
    (call $refinable
      (local.get $A)
    )
    (call $refinable
      (local.get $A)
    )
    (call $refinable
      (local.get $B)
    )
    (call $refinable
      (local.get $B)
    )
  )

  ;; ALWAYS:      (func $call-import (type $3) (param $B (ref $B))
  ;; ALWAYS-NEXT:  (call $import
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT: )
  ;; CAREFUL:      (func $call-import (type $4) (param $B (ref $B))
  ;; CAREFUL-NEXT:  (call $import
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT: )
  (func $call-import (param $B (ref $B))
    ;; Calls to imports are left as they are.
    (call $import
      (local.get $B)
    )
  )

  ;; ALWAYS:      (func $refinable (type $2) (param $ref (ref $A))
  ;; ALWAYS-NEXT:  (drop
  ;; ALWAYS-NEXT:   (local.get $ref)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT: )
  ;; CAREFUL:      (func $refinable (type $2) (param $0 (ref $A))
  ;; CAREFUL-NEXT:  (nop)
  ;; CAREFUL-NEXT: )
  (func $refinable (param $ref (ref $A))
    ;; Helper function for the above. Use the parameter to see we update types
    ;; etc when we make a refined version of the function (if we didn't,
    ;; validation would error).
    ;;
    ;; In CAREFUL mode we optimize to check if refined types help, which has the
    ;; side effect of optimizing the body of this function into a nop.
    (drop
      (local.get $ref)
    )
  )
)


;; ALWAYS:      (func $refinable_4 (type $3) (param $0 (ref $B))
;; ALWAYS-NEXT:  (local $ref (ref $A))
;; ALWAYS-NEXT:  (local.set $ref
;; ALWAYS-NEXT:   (local.get $0)
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT:  (drop
;; ALWAYS-NEXT:   (local.get $ref)
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT: )
(module
  ;; As above, but now the refinable function uses the local in a way that
  ;; requires a fixup.

  ;; ALWAYS:      (type $A (sub (struct)))
  ;; CAREFUL:      (type $A (sub (struct)))
  (type $A (sub (struct)))
  ;; ALWAYS:      (type $B (sub $A (struct)))
  ;; CAREFUL:      (type $B (sub $A (struct)))
  (type $B (sub $A (struct)))



  ;; ALWAYS:      (type $2 (func (param (ref $B))))

  ;; ALWAYS:      (type $3 (func (param (ref $A))))

  ;; ALWAYS:      (func $calls (type $2) (param $B (ref $B))
  ;; ALWAYS-NEXT:  (call $refinable_2
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT: )
  ;; CAREFUL:      (type $2 (func (param (ref $B))))

  ;; CAREFUL:      (type $3 (func (param (ref $A))))

  ;; CAREFUL:      (func $calls (type $2) (param $B (ref $B))
  ;; CAREFUL-NEXT:  (call $refinable
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT: )
  (func $calls (param $B (ref $B))
    (call $refinable
      (local.get $B)
    )
  )

  ;; ALWAYS:      (func $refinable (type $3) (param $ref (ref $A))
  ;; ALWAYS-NEXT:  (local $unref (ref $A))
  ;; ALWAYS-NEXT:  (local.set $unref
  ;; ALWAYS-NEXT:   (local.get $ref)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (local.set $ref
  ;; ALWAYS-NEXT:   (local.get $unref)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT: )
  ;; CAREFUL:      (func $refinable (type $3) (param $0 (ref $A))
  ;; CAREFUL-NEXT:  (nop)
  ;; CAREFUL-NEXT: )
  (func $refinable (param $ref (ref $A))
    (local $unref (ref $A))
    (local.set $unref
      (local.get $ref)
    )
    ;; If we refine $ref then this set will be invalid - we'd be setting a less-
    ;; refined type into a local/param that is more refined. We should fix this
    ;; up by using a temp local.
    (local.set $ref
      (local.get $unref)
    )
  )
)


;; ALWAYS:      (func $refinable_2 (type $2) (param $0 (ref $B))
;; ALWAYS-NEXT:  (local $unref (ref $A))
;; ALWAYS-NEXT:  (local $ref (ref $A))
;; ALWAYS-NEXT:  (local.set $ref
;; ALWAYS-NEXT:   (local.get $0)
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT:  (block
;; ALWAYS-NEXT:   (local.set $unref
;; ALWAYS-NEXT:    (local.get $ref)
;; ALWAYS-NEXT:   )
;; ALWAYS-NEXT:   (local.set $ref
;; ALWAYS-NEXT:    (local.get $unref)
;; ALWAYS-NEXT:   )
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT: )
(module
  ;; Multiple refinings of the same function, and of different functions.

  ;; ALWAYS:      (type $A (sub (struct)))
  ;; CAREFUL:      (type $A (sub (struct)))
  (type $A (sub (struct)))
  ;; ALWAYS:      (type $B (sub $A (struct)))
  ;; CAREFUL:      (type $B (sub $A (struct)))
  (type $B (sub $A (struct)))

  ;; ALWAYS:      (type $C (sub $B (struct)))
  ;; CAREFUL:      (type $2 (func (param (ref $A))))

  ;; CAREFUL:      (type $C (sub $B (struct)))
  (type $C (sub $B (struct)))

  ;; ALWAYS:      (type $3 (func (param (ref $A))))

  ;; ALWAYS:      (type $4 (func (param (ref $B))))

  ;; ALWAYS:      (type $5 (func (param (ref $A) (ref $B))))

  ;; ALWAYS:      (type $6 (func (param (ref $C) (ref $B))))

  ;; ALWAYS:      (type $7 (func (param (ref $C))))

  ;; ALWAYS:      (func $calls1 (type $5) (param $A (ref $A)) (param $B (ref $B))
  ;; ALWAYS-NEXT:  (call $refinable1
  ;; ALWAYS-NEXT:   (local.get $A)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (call $refinable1_4
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT: )
  ;; CAREFUL:      (type $4 (func (param (ref $A) (ref $B))))

  ;; CAREFUL:      (type $5 (func (param (ref $C) (ref $B))))

  ;; CAREFUL:      (func $calls1 (type $4) (param $A (ref $A)) (param $B (ref $B))
  ;; CAREFUL-NEXT:  (call $refinable1
  ;; CAREFUL-NEXT:   (local.get $A)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT:  (call $refinable1
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT: )
  (func $calls1 (param $A (ref $A)) (param $B (ref $B))
    (call $refinable1
      (local.get $A)
    )
    (call $refinable1
      (local.get $B)
    )
  )

  ;; ALWAYS:      (func $calls2 (type $6) (param $C (ref $C)) (param $B (ref $B))
  ;; ALWAYS-NEXT:  (call $refinable1_5
  ;; ALWAYS-NEXT:   (local.get $C)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (call $refinable2_6
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT: )
  ;; CAREFUL:      (func $calls2 (type $5) (param $C (ref $C)) (param $B (ref $B))
  ;; CAREFUL-NEXT:  (call $refinable1
  ;; CAREFUL-NEXT:   (local.get $C)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT:  (call $refinable2
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT: )
  (func $calls2 (param $C (ref $C)) (param $B (ref $B))
    (call $refinable1
      (local.get $C)
    )
    (call $refinable2
      (local.get $B)
    )
  )

  ;; ALWAYS:      (func $refinable1 (type $3) (param $ref (ref $A))
  ;; ALWAYS-NEXT:  (drop
  ;; ALWAYS-NEXT:   (local.get $ref)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT: )
  ;; CAREFUL:      (func $refinable1 (type $2) (param $0 (ref $A))
  ;; CAREFUL-NEXT:  (nop)
  ;; CAREFUL-NEXT: )
  (func $refinable1 (param $ref (ref $A))
    (drop
      (local.get $ref)
    )
  )

  ;; ALWAYS:      (func $refinable2 (type $3) (param $ref (ref $A))
  ;; ALWAYS-NEXT:  (drop
  ;; ALWAYS-NEXT:   (local.get $ref)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT: )
  ;; CAREFUL:      (func $refinable2 (type $2) (param $0 (ref $A))
  ;; CAREFUL-NEXT:  (nop)
  ;; CAREFUL-NEXT: )
  (func $refinable2 (param $ref (ref $A))
    (drop
      (local.get $ref)
    )
  )
)

;; ALWAYS:      (func $refinable1_4 (type $4) (param $0 (ref $B))
;; ALWAYS-NEXT:  (local $ref (ref $A))
;; ALWAYS-NEXT:  (local.set $ref
;; ALWAYS-NEXT:   (local.get $0)
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT:  (drop
;; ALWAYS-NEXT:   (local.get $ref)
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT: )

;; ALWAYS:      (func $refinable1_5 (type $7) (param $0 (ref $C))
;; ALWAYS-NEXT:  (local $ref (ref $A))
;; ALWAYS-NEXT:  (local.set $ref
;; ALWAYS-NEXT:   (local.get $0)
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT:  (drop
;; ALWAYS-NEXT:   (local.get $ref)
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT: )

;; ALWAYS:      (func $refinable2_6 (type $4) (param $0 (ref $B))
;; ALWAYS-NEXT:  (local $ref (ref $A))
;; ALWAYS-NEXT:  (local.set $ref
;; ALWAYS-NEXT:   (local.get $0)
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT:  (drop
;; ALWAYS-NEXT:   (local.get $ref)
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT: )
(module
  ;; A case where even CAREFUL mode will monomorphize, as it helps the target
  ;; function get optimized better.

  ;; ALWAYS:      (type $A (sub (struct)))
  ;; CAREFUL:      (type $A (sub (struct)))
  (type $A (sub (struct)))

  ;; ALWAYS:      (type $B (sub $A (struct)))
  ;; CAREFUL:      (type $B (sub $A (struct)))
  (type $B (sub $A (struct)))

  ;; ALWAYS:      (type $2 (func (param (ref $A) (ref $B))))

  ;; ALWAYS:      (type $3 (func (param (ref $B))))

  ;; ALWAYS:      (type $4 (func (param (ref $B) (ref $B))))

  ;; ALWAYS:      (import "a" "b" (func $import (type $3) (param (ref $B))))
  ;; CAREFUL:      (type $2 (func (param (ref $A) (ref $B))))

  ;; CAREFUL:      (type $3 (func (param (ref $B))))

  ;; CAREFUL:      (type $4 (func (param (ref $B) (ref $B))))

  ;; CAREFUL:      (import "a" "b" (func $import (type $3) (param (ref $B))))
  (import "a" "b" (func $import (param (ref $B))))

  ;; ALWAYS:      (global $global (mut i32) (i32.const 1))
  ;; CAREFUL:      (global $global (mut i32) (i32.const 1))
  (global $global (mut i32) (i32.const 1))

  ;; ALWAYS:      (func $calls (type $2) (param $A (ref $A)) (param $B (ref $B))
  ;; ALWAYS-NEXT:  (call $refinable
  ;; ALWAYS-NEXT:   (local.get $A)
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (call $refinable
  ;; ALWAYS-NEXT:   (local.get $A)
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (call $refinable_3
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (call $refinable_3
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT: )
  ;; CAREFUL:      (func $calls (type $2) (param $A (ref $A)) (param $B (ref $B))
  ;; CAREFUL-NEXT:  (call $refinable
  ;; CAREFUL-NEXT:   (local.get $A)
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT:  (call $refinable
  ;; CAREFUL-NEXT:   (local.get $A)
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT:  (call $refinable_3
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT:  (call $refinable_3
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT: )
  (func $calls (param $A (ref $A)) (param $B (ref $B))
    ;; The calls sending $B will switch to calling a refined version, as the
    ;; refined version is better, even in CAREFUL mode.
    (call $refinable
      (local.get $A)
      (local.get $B)
    )
    (call $refinable
      (local.get $A)
      (local.get $B)
    )
    (call $refinable
      (local.get $B)
      (local.get $B)
    )
    (call $refinable
      (local.get $B)
      (local.get $B)
    )
  )

  ;; ALWAYS:      (func $refinable (type $2) (param $ref (ref $A)) (param $B (ref $B))
  ;; ALWAYS-NEXT:  (local $x (ref $A))
  ;; ALWAYS-NEXT:  (call $import
  ;; ALWAYS-NEXT:   (ref.cast (ref $B)
  ;; ALWAYS-NEXT:    (local.get $ref)
  ;; ALWAYS-NEXT:   )
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (local.set $x
  ;; ALWAYS-NEXT:   (select (result (ref $A))
  ;; ALWAYS-NEXT:    (local.get $ref)
  ;; ALWAYS-NEXT:    (local.get $B)
  ;; ALWAYS-NEXT:    (global.get $global)
  ;; ALWAYS-NEXT:   )
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (call $import
  ;; ALWAYS-NEXT:   (ref.cast (ref $B)
  ;; ALWAYS-NEXT:    (local.get $x)
  ;; ALWAYS-NEXT:   )
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (call $import
  ;; ALWAYS-NEXT:   (ref.cast (ref $B)
  ;; ALWAYS-NEXT:    (local.get $x)
  ;; ALWAYS-NEXT:   )
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT:  (call $import
  ;; ALWAYS-NEXT:   (ref.cast (ref $B)
  ;; ALWAYS-NEXT:    (local.get $ref)
  ;; ALWAYS-NEXT:   )
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT: )
  ;; CAREFUL:      (func $refinable (type $2) (param $0 (ref $A)) (param $1 (ref $B))
  ;; CAREFUL-NEXT:  (local $2 (ref $B))
  ;; CAREFUL-NEXT:  (call $import
  ;; CAREFUL-NEXT:   (local.tee $2
  ;; CAREFUL-NEXT:    (ref.cast (ref $B)
  ;; CAREFUL-NEXT:     (local.get $0)
  ;; CAREFUL-NEXT:    )
  ;; CAREFUL-NEXT:   )
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT:  (call $import
  ;; CAREFUL-NEXT:   (local.tee $1
  ;; CAREFUL-NEXT:    (select (result (ref $B))
  ;; CAREFUL-NEXT:     (local.get $2)
  ;; CAREFUL-NEXT:     (local.get $1)
  ;; CAREFUL-NEXT:     (global.get $global)
  ;; CAREFUL-NEXT:    )
  ;; CAREFUL-NEXT:   )
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT:  (call $import
  ;; CAREFUL-NEXT:   (local.get $1)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT:  (call $import
  ;; CAREFUL-NEXT:   (local.get $2)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT: )
  (func $refinable (param $ref (ref $A)) (param $B (ref $B))
    ;; Note that this large function will end up optimized in CAREFUL mode, as a
    ;; side effect of our keeping optimizations we run for comparison purposes.

    (local $x (ref $A))
    ;; The refined version of this function will not have the cast, since
    ;; optimizations manage to remove it using the more refined type.
    ;;
    ;; (That is the case in CAREFUL mode, which optimizes; in ALWAYS mode the
    ;; cast will remain since we monomorphize without bothering to optimize and
    ;; see if there is any benefit.)
    (call $import
      (ref.cast (ref $B)
        (local.get $ref)
      )
    )
    ;; Also copy the param into a local. The local should get refined to $B in
    ;; the refined function in CAREFUL mode.
    (local.set $x
      ;; Use a select here so optimizations don't just merge $x and $ref.
      (select (result (ref $A))
        (local.get $ref)
        (local.get $B)
        (global.get $global)
      )
    )
    (call $import
      (ref.cast (ref $B)
        (local.get $x)
      )
    )
    (call $import
      (ref.cast (ref $B)
        (local.get $x)
      )
    )
    ;; Another use of $ref, also to avoid opts merging $x and $ref.
    (call $import
      (ref.cast (ref $B)
        (local.get $ref)
      )
    )
  )
)

;; ALWAYS:      (func $refinable_3 (type $4) (param $0 (ref $B)) (param $1 (ref $B))
;; ALWAYS-NEXT:  (local $x (ref $A))
;; ALWAYS-NEXT:  (local $ref (ref $A))
;; ALWAYS-NEXT:  (local $B (ref $B))
;; ALWAYS-NEXT:  (local.set $ref
;; ALWAYS-NEXT:   (local.get $0)
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT:  (local.set $B
;; ALWAYS-NEXT:   (local.get $1)
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT:  (block
;; ALWAYS-NEXT:   (call $import
;; ALWAYS-NEXT:    (ref.cast (ref $B)
;; ALWAYS-NEXT:     (local.get $ref)
;; ALWAYS-NEXT:    )
;; ALWAYS-NEXT:   )
;; ALWAYS-NEXT:   (local.set $x
;; ALWAYS-NEXT:    (select (result (ref $A))
;; ALWAYS-NEXT:     (local.get $ref)
;; ALWAYS-NEXT:     (local.get $B)
;; ALWAYS-NEXT:     (global.get $global)
;; ALWAYS-NEXT:    )
;; ALWAYS-NEXT:   )
;; ALWAYS-NEXT:   (call $import
;; ALWAYS-NEXT:    (ref.cast (ref $B)
;; ALWAYS-NEXT:     (local.get $x)
;; ALWAYS-NEXT:    )
;; ALWAYS-NEXT:   )
;; ALWAYS-NEXT:   (call $import
;; ALWAYS-NEXT:    (ref.cast (ref $B)
;; ALWAYS-NEXT:     (local.get $x)
;; ALWAYS-NEXT:    )
;; ALWAYS-NEXT:   )
;; ALWAYS-NEXT:   (call $import
;; ALWAYS-NEXT:    (ref.cast (ref $B)
;; ALWAYS-NEXT:     (local.get $ref)
;; ALWAYS-NEXT:    )
;; ALWAYS-NEXT:   )
;; ALWAYS-NEXT:  )
;; ALWAYS-NEXT: )

;; CAREFUL:      (func $refinable_3 (type $4) (param $0 (ref $B)) (param $1 (ref $B))
;; CAREFUL-NEXT:  (call $import
;; CAREFUL-NEXT:   (local.get $0)
;; CAREFUL-NEXT:  )
;; CAREFUL-NEXT:  (call $import
;; CAREFUL-NEXT:   (local.tee $1
;; CAREFUL-NEXT:    (select (result (ref $B))
;; CAREFUL-NEXT:     (local.get $0)
;; CAREFUL-NEXT:     (local.get $1)
;; CAREFUL-NEXT:     (global.get $global)
;; CAREFUL-NEXT:    )
;; CAREFUL-NEXT:   )
;; CAREFUL-NEXT:  )
;; CAREFUL-NEXT:  (call $import
;; CAREFUL-NEXT:   (local.get $1)
;; CAREFUL-NEXT:  )
;; CAREFUL-NEXT:  (call $import
;; CAREFUL-NEXT:   (local.get $0)
;; CAREFUL-NEXT:  )
;; CAREFUL-NEXT: )
(module
  ;; Test that we avoid recursive calls.

  ;; ALWAYS:      (type $A (sub (struct)))
  ;; CAREFUL:      (type $A (sub (struct)))
  (type $A (sub (struct)))
  ;; ALWAYS:      (type $B (sub $A (struct)))
  ;; CAREFUL:      (type $B (sub $A (struct)))
  (type $B (sub $A (struct)))


  ;; ALWAYS:      (type $2 (func (param (ref $B))))

  ;; ALWAYS:      (func $calls (type $2) (param $B (ref $B))
  ;; ALWAYS-NEXT:  (call $calls
  ;; ALWAYS-NEXT:   (local.get $B)
  ;; ALWAYS-NEXT:  )
  ;; ALWAYS-NEXT: )
  ;; CAREFUL:      (type $2 (func (param (ref $B))))

  ;; CAREFUL:      (func $calls (type $2) (param $B (ref $B))
  ;; CAREFUL-NEXT:  (call $calls
  ;; CAREFUL-NEXT:   (local.get $B)
  ;; CAREFUL-NEXT:  )
  ;; CAREFUL-NEXT: )
  (func $calls (param $B (ref $B))
    ;; We should change nothing in this recursive call, even though we are
    ;; sending a more refined type, so we could try to monomorphize in theory.
    (call $calls
      (local.get $B)
    )
  )
)

